#include<stdio.h>
#include<malloc.h>
#include"mincut.h"
#include<time.h>

float TOTAL_ADDED_DELAY=0;
int delay[10];
int count=0;
int *path,flag;

typedef struct list{
	int parent;
	float *min;
	struct list *next;
} node_list;

node_list **parentlist;


void insertInParentList(int node,int parent,float *min)
{
	node_list *p;
	p=parentlist[node];
	while(p!=NULL)
    {
		p=p->next;
	}
	p=(node_list*)malloc(sizeof(node_list));
	p->parent=parent;
	p->min=min;
	p->next=NULL;
}

float * insert(edge **list,int v_destination,float length)
{
  if(*list==NULL)
    {
      *list=(edge*)malloc(sizeof(edge));
      (*list)->data=v_destination;
      (*list)->weight=length;
      (*list)->next=NULL;
	  return &((*list)->min);
    }
  else
    return insert(&((*list)->next),v_destination,length);
}


void display_linked_list(edge *list,int v1)
{
  if(list==NULL)
    return;
  else
    {
		fprintf(f,"<%d, %d, %.1f, %.1f, %.1f>",v1,list->data,list->weight,list->min,list->max);
      display_linked_list(list->next,v1);
    }
}

void display_adjacency_list(edge **adjacency,int v)
{
  int i;
  fprintf(f,"\n");
  for(i=0;i<v;i++)
    {
      display_linked_list(adjacency[i],i);
      fprintf(f,"\n");
    }
}


int nodePresentInTheList(t_vertex_list list,int vertex){
	t_node *first;
	first = list.first;
	while(first){
		if(first->vertex == vertex){
			return 1;
		}
		first = first->next;
	}
	return 0;
}

float min(float x,float y){
	if(x<y){
		return x;
	}
	return y;
}

float acyclic_shortest_path2(int start,int goal,edge **adjacency)
{
  if(start==goal)
    return 0;
  else
    {
      if(visited[start]==1)
		return shortest_path[start];
      else
	{
	  float min,temp;
	  edge *list;
	  list=adjacency[start];
	  visited[start]=1;
	  min=100000;
	  while(list!=NULL)
	    {
	      temp=(list->weight)+acyclic_shortest_path2(list->data,goal,adjacency);
	      if(temp<min)
		{
		  min=temp;
		  path[start]=list->data;
		}
	      list=list->next;
	    }
	  shortest_path[start]=min;
	  return shortest_path[start];
	}
    }
}


float acyclic_longest_path2(int start,int goal,edge **adjacency)
{
  if(start==goal)
    return 0;
  else
    {
      if(visited2[start]==1)
	return longest_path[start];
      else
	{
	  float max,temp;
	  edge *list;
	  list=adjacency[start];
	  visited2[start]=1;
	  max=-100000;
	  while(list!=NULL)
	    {
	      temp=(list->weight)+acyclic_longest_path2(list->data,goal,adjacency);
		  //printf("temp = %f\n",temp);
	      if(temp>max)
		{
		  max=temp;
		  path[start]=list->data;
		}
	      list=list->next;
	    }
	  longest_path[start]=max;
	  return longest_path[start];
	}
    }
}

void prepare_ai(edge **adjacency,int j,float weight){
	acyclic_shortest_path2(0,1,adjacency);
	acyclic_longest_path2(0,1,adjacency);
}

void prepare_ai2(edge **adjacency,int v,int i,float weight){
	edge *p;
	if(ai[i]>weight)
		ai[i]=weight;
	if(Ai[i]<weight)
		Ai[i]=weight;
	if(i==1){
		return;
	}
	p = adjacency[i];
	while(p){
		prepare_ai2(adjacency,v,p->data,weight+p->weight);
		p=p->next;	
	}
}
void delayDistribution(edge **adjacency,int v,int i,float weight){
	edge *p;
	if(i==1){
		count++;
		//printf("asdaf\n%d",(int)(10*(weight-MIN)/(MAX-MIN)));
		delay[(int)(10*(weight-MIN)/(MAX-MIN))]++;
		return;
	}
	p = adjacency[i];
	while(p){
		delayDistribution(adjacency,v,p->data,weight+p->weight);
		p=p->next;	
	}
}

void setMinMax(edge **adjacency,int v,int i,float weight){
	edge *p;
	if(i==1)
		return;
	p = adjacency[i];
	while(p){
		p->max = Ai[i]+longest_path[p->data]+p->weight;
		p->min = ai[i]+shortest_path[p->data]+p->weight;	
		setMinMax(adjacency,v,p->data,weight+p->weight);
		p=p->next;	
	}
}


void update(int v,edge **adjacency){
	for(int i=0;i<v;i++)
  {
	  ai[i]=999;
	  Ai[i]=0;
	  shortest_path[i]=0;
		longest_path[i]=0;
		visited[i]=0;
		visited2[i]=0;
		path[i]=-1;
		ri[i]=-999;
		Ri[i]=-999;
  }
	prepare_ai(adjacency,v,0);
	prepare_ai2(adjacency,v,0,0);
	setMinMax(adjacency,v,0,0);
}


void change(int i,edge **adjacency){
	edge *p;
	p=adjacency[i];
	while(p){
		p->min = 99999;
		change(p->data,adjacency);
		p=p->next;
	}
}

void change2(int i){
	node_list *p;
	p=parentlist[i];
	while(p){
			*(p->min)= 99999;
			change2(p->parent);
			p=p->next;
	}
}

void addDelay(edge **adjacency,int v,t_solution solution){
	struct t_node *p = solution.cutset.first;
	edge *q;
	for(int i=0;i<v;i++){
		if(!nodePresentInTheList(solution.cutset,i)){
			q = adjacency[i];
			while(q){
				if(nodePresentInTheList(solution.cutset,q->data)&&(q->min<THRESHOLD)){//check
					q->weight += min((THRESHOLD-q->min),(MAX-q->max));//check
					TOTAL_ADDED_DELAY+=min((THRESHOLD-q->min),(MAX-q->max));//check
					fprintf(f,"\nadded weight to somebody%d to %d and weight is now %f",i,q->data,q->weight);
					//fprintf(foutput,"\nadded weight to somebody%d to %d and weight is now %f",i,q->data,q->weight);
					//update(v,adjacency);
					change(q->data,adjacency);
					change2(q->data);
				}
				q=q->next;
			}
		}
	}
}
edge ** readFromFile(int *v){
	int e;
	int inputs,outputs;
	int i,v_source,v_destination;
	float weight;
	FILE *f;
	f = fopen("c432.maxgraph","r");
	edge **adjacency;
	fscanf(f,"%d",v);
	fscanf(f,"%d",&e);
	fscanf(f,"%d",&inputs);
	fscanf(f,"%d",&outputs);
	adjacency=(edge**)malloc((*v+2)*sizeof(edge*));
	for(i=0;i<*v+2;i++){
		adjacency[i]=NULL;
    }
	for(i=1;i<=inputs;i++){
		insert(&adjacency[0],i,0);
	}
	for(i=0;i<e;i++)
    {
		fscanf(f,"%d%d%f",&v_source,&v_destination,&weight);
		insert(&adjacency[v_source],v_destination,weight);
    }
	for(i=*v;i>*v-outputs;i--){
		insert(&adjacency[i],*v+1,0);
	}
	float temp;
	edge *r;
	for(i=1;i<=*v;i++){
		fscanf(f,"%f",&temp);
		r = adjacency[i];
		while(r){
			r->weight+=temp;
			r=r->next;
		}
	}
	*v=*v+2;
	return adjacency;
}

edge ** readFromFile2(int *v){
	int e;
	int inputs,outputs;
	int i,v_source,v_destination;
	float weight;
	//char str[20];
	FILE *f;
	f = fopen("c499.maxgraph","r");
	edge **adjacency;
	fscanf(f,"%d",&inputs);
	fscanf(f,"%d",&outputs);
	fscanf(f,"%d",v);
	fscanf(f,"%d",&e);
	ri = (float *)malloc((*v)*sizeof(float));
	Ri = (float *)malloc((*v)*sizeof(float));
	ai = (float *)malloc((*v)*sizeof(float));
	Ai = (float *)malloc((*v)*sizeof(float));
	delta = (float *)malloc((*v)*sizeof(float));
	visited=(float*)malloc((*v)*sizeof(float));
	visited2=(float*)malloc((*v)*sizeof(float));
	visited3=(float*)malloc((*v)*sizeof(float));
	shortest_path=(float*)malloc((*v)*sizeof(float));
	longest_path=(float*)malloc((*v)*sizeof(float));
	path=(int*)malloc((*v)*sizeof(int));
	adjacency=(edge**)malloc((*v)*sizeof(edge*));
	parentlist = (node_list**)malloc((*v)*sizeof(node_list));
	for(i=0;i<*v;i++){
		adjacency[i]=NULL;
		parentlist[i]=NULL;
		visited[i]=-1;
		visited2[i]=-1;
		visited3[i]=-1;
		shortest_path[i]=0;
		longest_path[i]=0;
		path[i]=-1;
		ri[i]=-999;
		Ri[i]=-999;
		Ai[i]=0;
		ai[i]=999;
	}
	float *test;
	for(i=0;i<e;i++)
    {
		fscanf(f,"%d%d%f",&v_source,&v_destination,&weight);
		test = insert(&adjacency[v_source],v_destination,weight);
		insertInParentList(v_destination,v_source,test);
    }
	float temp;
	edge *r;
	for(i=2;i<*v;i++){
		fscanf(f,"%f",&temp);
		r = adjacency[i];
		while(r){
			r->weight+=temp;
			r=r->next;
		}
	}
	//reverseAdjacency(adjacency,*v);
	return adjacency;
}

int main(){
	int v,i;
	time_t start,end;
	double dif;
	time (&start);
	edge ** adjacency = readFromFile2(&v);
	prepare_ai(adjacency,v,0);
	prepare_ai2(adjacency,v,0,0);
	setMinMax(adjacency,v,0,0);
	MIN = shortest_path[0];
	MAX = longest_path[0];
	//fprintf(foutput,"\nmin and max value %f , %f\n",MIN,MAX);
	fprintf(f,"\nmin and max value %f , %f\n",MIN,MAX);
	fprintf(f,"\nadjacency list follows\n");
	//display_adjacency_list(adjacency,v);
	fprintf(f,"\ndistribution list follows\n");
	delayDistribution(adjacency,v,0,0);
	fprintf(f,"\nno of paths %d\n",count);
	for(i=0;i<10;i++){
		fprintf(f,"\n%d",delay[i]);
		delay[i]=0;
	}
	THRESHOLD = MAX/4;
	for(i=0;i<v;i++){
		ri[i]=THRESHOLD-shortest_path[i];
		Ri[i]=MAX-longest_path[i];
		delta[i]=ri[i]-ai[i];
	  //printf("%.1f   ",ri[i]);
	  //printf("%.1f   ",Ri[i]);
	  //printf("%.1f   ",ai[i]);
	  //printf("%.1f   ",Ai[i]);
	  //printf("%.1f   ",shortest_path[i]);
	  //printf("%.1f   ",longest_path[i]);
  }
  struct t_problem prob = read_problem2(adjacency,v);
  struct t_solution solution = solve_problem(prob);
  addDelay(adjacency,v,solution);
  //acyclic_shortest_path3(0,1,adjacency);
  
  for(int j=0;j<3&&MIN<.95*THRESHOLD;j++)
  {
    update(v,adjacency);
	//display_adjacency_list(adjacency,v);
	MIN = shortest_path[0];
	MAX = longest_path[0];
	count =0;
	delayDistribution(adjacency,v,0,0);
	for(i=0;i<10;i++){
		fprintf(f,"\n%d",delay[i]);
		delay[i]=0;
	}
	//fprintf(foutput,"\nmin and max value %f , %f\n",MIN,MAX);
	fprintf(f,"\nmin and max value %f , %f\n",MIN,MAX);
  time (&end);
  dif = difftime (end,start);
  fprintf(f,"\ntotal time taken to add delay: %f\ntotal added delay = %f\n",dif,TOTAL_ADDED_DELAY);
  //fprintf(foutput,"total time taken to add delay: %f\n\n\n\n\n\n%f",dif,TOTAL_ADDED_DELAY);
  prob = read_problem2(adjacency,v);
  solution = solve_problem(prob);
  addDelay(adjacency,v,solution);
  //acyclic_shortest_path3(0,1,adjacency);
}  
  update(v,adjacency);
	//display_adjacency_list(adjacency,v);
	MIN = shortest_path[0];
	MAX = longest_path[0];
	count =0;
	delayDistribution(adjacency,v,0,0);
	for(i=0;i<10;i++){
		fprintf(f,"\n%d",delay[i]);
		delay[i]=0;
	}
	//fprintf(foutput,"\nmin and max value %f , %f\n",MIN,MAX);
	fprintf(f,"\nmin and max value %f , %f\n",MIN,MAX);
  time (&end);
  dif = difftime (end,start);
  fprintf(f,"\ntotal time taken to add delay: %f\ntotal added delay = %f\n",dif,TOTAL_ADDED_DELAY);
  printf("end ");
//  acyclic_shortest_path3(0,1,adjacency);

  free_vertex_list(solution.cutset); 
  free(adjacency);
  fclose(f);
  //free(p);*/
  scanf("%d",&i);
return 0;
}


